function Pag11002_RelatorioCustomizavelTitulosPagarPagos_Controller (General, ScreenService, templateManager, ZHPromise, ZhFilterPreferences, restEngine) {
    var self = this; 
    
    self.setNameLayout = function(args){
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
     
    self.openFilterTitulosAPagar = function(widgetTitulosAPagar){
        self.buscaDadosIniciaisFiltro(widgetTitulosAPagar).then(function(){
            var rowSetFilter = {
                //'DTVENBOLPAG' : widgetTitulosAPagar.DTVENBOLPAG,
                'CDEMPRESA'   : widgetTitulosAPagar.empresa.CDEMPRESA,
                'NMEMPRESA'   : widgetTitulosAPagar.empresa.NMEMPRESA
            };
            ZhFilterPreferences.setOriginalFilter(widgetTitulosAPagar.id, rowSetFilter);
            ZhFilterPreferences.openFilterWidget(widgetTitulosAPagar, rowSetFilter);
        });

    };
    
    self.buscaDadosIniciaisFiltro = function(widgetTitulosAPagar) {
        var deferred = ZHPromise.defer();
        self.buscaPadraoEmpresa(widgetTitulosAPagar).then(function(){
            self.buscaPadraoIntervaloVencimento(widgetTitulosAPagar).then(function(){
                deferred.resolve();        
            });    
        });
        
        return deferred.promise;
    };
    
    self.buscaPadraoEmpresa = function(widget) {
        var deferred = ZHPromise.defer();
        var filterFilial = [{"name": "CDFILIAL", "operator": "=", "value": "FILIAL_LOGADA"}];
        var routeFilial = 'fin#/crud/filial';
        General.callRestEngine(routeFilial, 'FilterData', filterFilial).then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var routeEmpresa = 'fin#/crud/empresa';
            var filterEmpresa = [{"name": "CDEMPRESA", "operator": "=", "value": filial.CDEMPRESA}];
            General.callRestEngine(routeEmpresa, 'FilterData', filterEmpresa).then(function(response_empresa){
                var empresa = response_empresa.dataset.empresa[0];
                widget.empresa = empresa;
                deferred.resolve();
            });
        });
        
        return deferred.promise;
    };
    
    self.buscaGeralPag = function(){
        return General.callRestEngine(
            'fin#/crud/geral_pag',
            'FilterData',
            []
        );
    };
    
    self.buscaParamEstoque = function(cdFilialOpcional) {
        var filter = [{"name": "CDFILIAL", "operator": "=", "value": 'FILIAL_LOGADA'}];
        return General.callRestEngine(
            'fin#/crud/paramestoque_processamento',
            'FilterData',
            filter
        );
    };
    
    self.buscaPadraoIntervaloVencimento = function (widget){
        var deferred = ZHPromise.defer();
        var geralpag     = self.buscaGeralPag();
        var paramestoque = self.buscaParamEstoque();

        ZHPromise.all([geralpag, paramestoque]).then(function(response){
            geralpag     = response[0].dataset.geral_pag[0];
            paramestoque = response[1].dataset.paramestoque_processamento[0];

            var qtdiaantlanr = geralpag?geralpag.QTDIAANTBOLP?geralpag.QTDIAANTBOLP:0:0;
            var qtdiaapolanr = geralpag?geralpag.QTDIAAPOBOLP?geralpag.QTDIAAPOBOLP:0:0;
            var dtprocessa   = paramestoque?paramestoque.DTPROCESSA?paramestoque.DTPROCESSA:moment():moment();

            var start = moment(dtprocessa, 'DD/MM/YYYY').subtract(qtdiaantlanr, 'days').format('DD/MM/YYYY');
            var end   = moment(dtprocessa, 'DD/MM/YYYY').add(qtdiaapolanr, 'days').format('DD/MM/YYYY');

            //widget.DTVENBOLPAG = {start : start, end : end};
            deferred.resolve();
        });
        return deferred.promise;
    };
    
    
    self.buildFilter = function (widget, preference) {
        var filtro = widget.dataSourceFilter;
        var filterRow = preference.FILTER_ROW;
        
        filtro.forEach(function(fil) {
            if (Array.isArray(fil.value)) {
                fil.value = fil.value.join("_");
            }
            switch (fil.name) {
                
                case 'VALORINI':
                    fil.value = filterRow.VALORINI ? filterRow.VALORINI : null;
                    break;
                
                case 'VALORFIN':
                    fil.value = filterRow.VALORFIN ? filterRow.VALORFIN : null;
                    break;
                
                case 'DATENTR':
                    fil.value = filterRow.ENTRADA ? filterRow.ENTRADA.start : null;
                    break;
                
                case 'DATSAID':
                    fil.value = filterRow.ENTRADA ? filterRow.ENTRADA.end : null;
                    break;
                
                case 'DATEMISINI':
                    fil.value = filterRow.EMISSAO ? filterRow.EMISSAO.start : null;
                    break;
                
                case 'DATEMIFIN':
                    fil.value = filterRow.EMISSAO ? filterRow.EMISSAO.end : null;
                    break;
                
                case 'DTATUAVENPAGFIN':
                    fil.value = filterRow.VENCIMENTO ? filterRow.VENCIMENTO.start : null;
                    break;
                
                case 'DTATUAVENPAGINI':
                    fil.value = filterRow.VENCIMENTO ? filterRow.VENCIMENTO.end : null;
                    break;
                
                case 'IDTPCTPAGAR':
                    fil.value = filterRow.IDTPCTPAGAR ? filterRow.IDTPCTPAGAR : null;
                    break;
                
                case 'CODFILILANC':
                    fil.value = filterRow.CDFILIAL ? filterRow.CDFILIAL : 'T';
                    break;
                
                case 'STATUS':
                    fil.value = filterRow.STATUS ? filterRow.STATUS : 'T';
                    break;
                
                case 'TIPO':
                    fil.value = filterRow.IDSTATUS ? filterRow.IDSTATUS : 'A_E'; 
                    break;
                
                case 'TIPOCONTA':
                    fil.value = filterRow.CDTPCTPAGAR ? filterRow.CDTPCTPAGAR : 'T';
                    break;
                
                case 'P_CLASSFINA':
                    fil.value = filterRow.CDCLASSFINA ? filterRow.CDCLASSFINA: 'T';
                    break;
                
                case 'IDBLOQNFFIN':
                    if(filterRow.IDBLOQNFFIN == null){
                        filterRow.IDBLOQNFFIN = 'L';
                    }
                    fil.value = filterRow.IDBLOQNFFIN ? filterRow.IDBLOQNFFIN : 'L';
                    break;
                
                case 'HABILITA':
                    fil.value = filterRow.IDHABIBPAG ? filterRow.IDHABIBPAG : 'T';
                    break;
                
                case 'P_FORMA':
                    fil.value = filterRow.CDTPBAIXAPAG ? filterRow.CDTPBAIXAPAG : 'T';
                    break;
                
                case 'P_CCORR':
                    fil.value = filterRow.CDREDUCONT ? filterRow.CDREDUCONT : 'T';
                    break;
                                
                case 'P_TOPERLANC':
                    fil.value = filterRow.CDOPERACTPG ? null : 'T';
                    break;
                
                case 'P_OPERLANC':
                    fil.value = filterRow.CDOPERACTPG ? filterRow.CDOPERACTPG : null;
                    break;
                
                 case 'P_TCDTIPOOPER':
                    fil.value = filterRow.CDTIPOOPER ? null : 'T';
                    break;
                
                case 'P_CDTIPOOPER':
                    fil.value = filterRow.CDTIPOOPER ? filterRow.CDTIPOOPER : null;
                    break;
                    
                case 'P_PRIPUB':
                    fil.value = filterRow.P_PRIPUB ? filterRow.P_PRIPUB : 'T';
                    break;
                    
                case 'IDSISTEMA':
                    fil.value = filterRow.IDSISTEMA ? filterRow.IDSISTEMA : 'T';
                    break;
                
            }
        });
        
        filtro = getDataSourceWithoutIntervalFieldNames(filtro);
    };
    
    self.changeInputValues = function(widget, preference) {
        var filterRow = preference.FILTER_ROW;
        validateStartEndValues(filterRow);
    };
    
    //Limpa os nomes dos campos invterval do dataSource
    var getDataSourceWithoutIntervalFieldNames = function(filtro){
        for(var i = 0; i < filtro.length; i++) {
            if(filtro[i].name === 'DTEMISSAO' ||
               filtro[i].name === 'DTENTRSAID' ||
               filtro[i].name === 'DTVENBOLPAG' ||
               filtro[i].name === 'DTBAIXAPAG' ) {
                filtro.splice(i, 1);
                i--;
            }
        } 
        return filtro;
    };
    
    /*
     * Verificação para igualar valores iniciais e finais do filtro, no caso
     * do usuário preencher um e deixar o outro em branco. Isso irá fazer
     * com que a query retorne somente resultados que sejam exatamente os  
     * mesmos valores inseridos em um dos campos.
     */
    var validateStartEndValues = function(filterRow) {
        // Verifica valor líquido inicial e final.
        filterRow.VRFINALBPAGINI = filterRow.VRFINALBPAGINI || filterRow.VRFINALBPAGFIN || null;
        filterRow.VRFINALBPAGFIN = filterRow.VRFINALBPAGFIN || filterRow.VRFINALBPAGINI;
        
        // Verifica nota fiscal inicial e final.
        filterRow.NRNOTAFISCINI = filterRow.NRNOTAFISCINI || filterRow.NRNOTAFISCFIN || null;
        filterRow.NRNOTAFISCFIN = filterRow.NRNOTAFISCFIN || filterRow.NRNOTAFISCINI;
        
        // Verifica valor da baixa inicial e final.
        filterRow.VRBAIXAPAGINI = filterRow.VRBAIXAPAGINI || filterRow.VRBAIXAPAGFIN || null;
        filterRow.VRBAIXAPAGFIN = filterRow.VRBAIXAPAGFIN || filterRow.VRBAIXAPAGINI;
        
        // Verifica número remessa inicial e final.
        // Verifica valor remessa inicial e final.
        filterRow.VRTOTBOLCNABPAGINI = filterRow.VRTOTBOLCNABPAGINI || filterRow.VRTOTBOLCNABPAGFIN || null;
        filterRow.VRTOTBOLCNABPAGFIN = filterRow.VRTOTBOLCNABPAGFIN || filterRow.VRTOTBOLCNABPAGINI;
    };
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Pag11002_RelatorioCustomizavelTitulosPagarPagos_Controller', Pag11002_RelatorioCustomizavelTitulosPagarPagos_Controller);
});